== Description ==

Red-black matrix is a simple method to increase concurrency evaluating
a gradient descent.  The idea is to break the dependency between the
cells in the matrix and put them in two groups. This helps to execute
each iteration of the simulation in more than one parallel loop.

== How to do the exercises ==

*_exercise_*(e.g. c_exercise_red_black.c) files contain the exercises, please choose a exercise file based
on whichever programming language you are familiar with (c/c++,Fortran).
Open the exercise file, modify it with OpenMP pragma and runtime routines.

[Solution files are also provided. They follow the naming convention *_solution_*.]

== Compilation and running on the training machines with training accounts ==

=== Compilation ===

source build_job.sh <compiler name (cray, intel, gnu, pgi)>

e.g. source build_job.sh cray

=== Running ===

Batch mode(easy to do, same command will work for all machines)
---------------------------------------------------------------
    source run_job.sh <executable name>

    e.g. source run_job.sh c_exercise_red_black.x 
    
Interactive mode (a bit more work, but more useful for development and testing)
-------------------------------------------------------------------
    For Blue Waters:
    ----------------
    1. Allocate a compute node for 1 hour,
        qsub -I -l nodes=1:ppn=32:xe -l walltime=01:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_red_black.x
    For Cori:
    ---------
    1. Allocate a haswell compute node for 1 hour,
        salloc -N 1 -C haswell -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_red_black.x
    For Edison:
    -----------
    1. Allocate a compute node for 1 hour,
        salloc -N 1 -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_red_black.x
    For Stampede2:
    --------------
    1. Allocate a KNL compute node for 1 hour,
        idev -p normal -N 1 -n 68 -m 60
    2. Once allocated, run the program like any executable
        ./c_exercise_red_black.x
        
====================================================================================

== Compilation and running on other machines or with different accounts ==

=== Compilation ===

make compiler=<comiler name (cray, intel, gnu, pgi)>
e.g. make comiler=cray

=== Running ===

./<executable name>

e.g. ./c_exercise_red_black.x

== Description ==

Provides different version of jacobi,
    -OpenMP 3.1 version of Jacobi (jacobi.f)
    -OpenMP 4.5 version of Jacobi (jacobi-accel.f)

== How to do the exercises ==

== Compilation and running on the training machines with training accounts ==
Go to the jacobi folder,
    cd jacobi
    
=== Compilation ===

The run the build script,
    source build_job.sh <compiler>
compiler = intel | cray
The build script supports Blue Waters (Cray XK), Titan (Cray XK7), Chester (Cray XK7), Eos (Cray XC31), and Beacon (Intel Xeon Phi).

On Blue Waters only cray compiler is supported.

When the build script is successful, it will build three versions of the Jacobi code:
    - j.<compiler>: OpenMP 3.1 version of Jacobi
    - jacc.<compiler>: OpenMP 4.5 version of Jacobi, compiled to run on the accelerator
    - jacc.host.<compiler>: OpenMP 4.5 version of Jacobi compiled to run on the host (CPU)    

=== Running ===

Batch mode(easy to do, same command will work for all machines)
---------------------------------------------------------------
    source run_job.sh <executable name>

    e.g. source run_job.sh jacc.cray
    
Interactive mode (a bit more work, but more useful for development and testing)
-------------------------------------------------------------------
    For Blue Waters:
    ----------------
    1. Allocate a compute node for 1 hour,
        qsub -I -l nodes=2:ppn=16:xk -l walltime=01:00:00
    2. Once allocated, run the program like any executable
        ./jacc.cray
        

1. The source codes

"xthi-omp.c" is a pure OpenMP code to show thread affinity.
"xthi-nested-omp.c" is a nested OpenMP code to show thread affinity.
"xthi.c" is a hybrid MPI/OpenMP code to show process and thread affinity.

This README will show how to compile and run the pure OpenMP codes
(xthi-omp.c, and xthi-nested-omp.c) and hybird MPI/OpenMP code (xthi.c)
on NERSC Cori XC40 system Haswell and KNL compute nodes, NCSA BlueWaters 
XC30 system AMD compute nodes, and TACC Stampede2 KNL compute nodes.

Users are encouraged to explore and understand the impact of different 
runtime options to the process and thread affinity. For example:
Choices for OMP_PROC_BIND are close, master, true, false.
Choices for OMP_PLACES are : cores, sockets, and various ways to specify 
explicit lists, etc.

2. Use Cori Intel Haswell compute nodes

2.1 Compile 
To compile, from a Haswell login node. The default is Intel compiler.
% cc -qopenmp -o xthi-omp xthi-omp.c
% cc -qopenmp -o xthi-nested-omp xthi-nested-omp.c
% cc -qopenmp -o xthi xthi.c

To compile with GNU compiler:
% module swap PrgEnv-intel PrgEnv-gnu
% cc -fopenmp -o xthi-omp xthi-omp.c
% cc -fopenmp -o xthi-nested-omp xthi-nested-omp.c
% cc -fopenmp -o xthi xthi.c


To compile with Cray compiler:
% module swap PrgEnv-intel PrgEnv-cray
% cc -o xthi-omp xthi-omp.c
% cc -o xthi-nested-omp xthi-nested-omp.c
% cc -o xthi xthi.c

2.2 Request a compute node via interactive batch:

% salloc -N 1 -C haswell -p debug -t 30:00
or, if there is a reservation, such as "petascale": 
% salloc -N 1 -C haswell -p regular --reservation=petascale -t 1:00:00
...
You will then get on a compute node.

2.3 Check NUMA and hardware configuration

nid00011% numactl -H
available: 2 nodes (0-1)
node 0 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47
node 0 size: 64430 MB
node 0 free: 63002 MB
node 1 cpus: 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63
node 1 size: 64635 MB
node 1 free: 63395 MB
node distances:
node   0   1 
  0:  10  21 
  1:  21  10 

2.4 Run 

nid00011% export OMP_NUM_THREADS=8

No default binding:
nid00011% ./xthi-omp |sort -k6n
Hello from thread 0, on nid00011. (core affinity = 0-63)
Hello from thread 1, on nid00011. (core affinity = 0-63)
Hello from thread 2, on nid00011. (core affinity = 0-63)
Hello from thread 3, on nid00011. (core affinity = 0-63)
Hello from thread 4, on nid00011. (core affinity = 0-63)
Hello from thread 5, on nid00011. (core affinity = 0-63)
Hello from thread 6, on nid00011. (core affinity = 0-63)
Hello from thread 7, on nid00011. (core affinity = 0-63)

OMP_PROC_BIND being "spread" is useful. Let's also set OMP_PLACES=cores:
(threads can migrate within the core):
nid00011% export OMP_PROC_BIND=spread
nid00011% export OMP_PLACES=cores  
nid00011% ./xthi-omp |sort -k6n
Hello from thread 0, on nid00011. (core affinity = 0,32)
Hello from thread 1, on nid00011. (core affinity = 4,36)
Hello from thread 2, on nid00011. (core affinity = 8,40)
Hello from thread 3, on nid00011. (core affinity = 12,44)
Hello from thread 4, on nid00011. (core affinity = 16,48)
Hello from thread 5, on nid00011. (core affinity = 20,52)
Hello from thread 6, on nid00011. (core affinity = 24,56)
Hello from thread 7, on nid00011. (core affinity = 28,60)

Now try to set the OMP_PLACES=threads:
(each thread is bind to a logical core, one of the two hyperthreads of a single core)
nid00011% export OMP_PLACES=threads
nid00011% ./xthi-omp |sort -k6n
Hello from thread 0, on nid00011. (core affinity = 0)
Hello from thread 1, on nid00011. (core affinity = 4)
Hello from thread 2, on nid00011. (core affinity = 8)
Hello from thread 3, on nid00011. (core affinity = 12)
Hello from thread 4, on nid00011. (core affinity = 16)
Hello from thread 5, on nid00011. (core affinity = 20)
Hello from thread 6, on nid00011. (core affinity = 24)
Hello from thread 7, on nid00011. (core affinity = 28)

Let's also try OMP_PLACES=sockets:
(each thread can freely move within a socket, 4 threads will bind to first 
socket and 4 threads will bind to the second socket).
nid00011% export OMP_PLACES=sockets
nid00011%./xthi-omp |sort -k6n
Hello from thread 0, on nid00011. (core affinity = 0-15,32-47)
Hello from thread 1, on nid00011. (core affinity = 0-15,32-47)
Hello from thread 2, on nid00011. (core affinity = 0-15,32-47)
Hello from thread 3, on nid00011. (core affinity = 0-15,32-47)
Hello from thread 4, on nid00011. (core affinity = 16-31,48-63)
Hello from thread 5, on nid00011. (core affinity = 16-31,48-63)
Hello from thread 6, on nid00011. (core affinity = 16-31,48-63)
Hello from thread 7, on nid00011. (core affinity = 16-31,48-63)

If you give an explicit list of OMP_PLACES, it will bind to these places only, 
such as:
nid00011% export OMP_PLACES=0,1,2,3
nid00011% ./xthi-omp |sort -k6n
Hello from thread 0, on nid00011. (core affinity = 0)
Hello from thread 1, on nid00011. (core affinity = 0)
Hello from thread 2, on nid00011. (core affinity = 1)
Hello from thread 3, on nid00011. (core affinity = 1)
Hello from thread 4, on nid00011. (core affinity = 2)
Hello from thread 5, on nid00011. (core affinity = 2)
Hello from thread 6, on nid00011. (core affinity = 3)
Hello from thread 7, on nid00011. (core affinity = 3)


Tests with "xthi-nested":
nid00011% export OMP_NUM_THREADS=4,3

OMP_PROC_BIND set to "spread,close" is recommended: outer layer "spread", 
inner layer "close":
nid00011% export OMP_PROC_BIND=spread,close
nid00011% export OMP_PLACES=threads

But it only have one OpenMP level!
nid00011% ./xthi-nested-omp |sort -k4,6
Hello from level 1: thread level 1= 0, on nid00011. (core affinity = 0)
Hello from level 1: thread level 1= 1, on nid00011. (core affinity = 8)
Hello from level 1: thread level 1= 2, on nid00011. (core affinity = 16)
Hello from level 1: thread level 1= 3, on nid00011. (core affinity = 24)
Hello from level 2: thread level 1=  0, thread level 2= 0, on nid00011. (core affinity = 0)
Hello from level 2: thread level 1=  1, thread level 2= 0, on nid00011. (core affinity = 8)
Hello from level 2: thread level 1=  2, thread level 2= 0, on nid00011. (core affinity = 16)
Hello from level 2: thread level 1=  3, thread level 2= 0, on nid00011. (core affinity = 24)

Now set the following two run time environment variables, it gets 2 levels 
with desired thread affinity:
nid00011% export OMP_NESTED=true
nid00011% export OMP_MAX_ACTIVE_LEVELS=2

nid00011% ./xthi-nested-omp |sort -k4,6
Hello from level 1: thread level 1= 0, on nid00011. (core affinity = 0)
Hello from level 1: thread level 1= 1, on nid00011. (core affinity = 8)
Hello from level 1: thread level 1= 2, on nid00011. (core affinity = 16)
Hello from level 1: thread level 1= 3, on nid00011. (core affinity = 24)
Hello from level 2: thread level 1=  0, thread level 2= 0, on nid00011. (core affinity = 0)
Hello from level 2: thread level 1=  0, thread level 2= 1, on nid00011. (core affinity = 32)
Hello from level 2: thread level 1=  0, thread level 2= 2, on nid00011. (core affinity = 1)
Hello from level 2: thread level 1=  1, thread level 2= 0, on nid00011. (core affinity = 8)
Hello from level 2: thread level 1=  1, thread level 2= 1, on nid00011. (core affinity = 40)
Hello from level 2: thread level 1=  1, thread level 2= 2, on nid00011. (core affinity = 9)
Hello from level 2: thread level 1=  2, thread level 2= 0, on nid00011. (core affinity = 16)
Hello from level 2: thread level 1=  2, thread level 2= 1, on nid00011. (core affinity = 48)
Hello from level 2: thread level 1=  2, thread level 2= 2, on nid00011. (core affinity = 17)
Hello from level 2: thread level 1=  3, thread level 2= 0, on nid00011. (core affinity = 24)
Hello from level 2: thread level 1=  3, thread level 2= 1, on nid00011. (core affinity = 56)
Hello from level 2: thread level 1=  3, thread level 2= 2, on nid00011. (core affinity = 25)

See non-optimal thread affinity with OMP_PROC_BIND=close,close below:
nid00011% export OMP_PROC_BIND=close,close 
nid00011% ./xthi-nested-omp |sort -k4,6
Hello from level 1: thread level 1= 0, on nid00011. (core affinity = 0)
Hello from level 1: thread level 1= 1, on nid00011. (core affinity = 32)
Hello from level 1: thread level 1= 2, on nid00011. (core affinity = 1)
Hello from level 1: thread level 1= 3, on nid00011. (core affinity = 33)
Hello from level 2: thread level 1=  0, thread level 2= 0, on nid00011. (core affinity = 0)
Hello from level 2: thread level 1=  0, thread level 2= 1, on nid00011. (core affinity = 32)
Hello from level 2: thread level 1=  0, thread level 2= 2, on nid00011. (core affinity = 1)
Hello from level 2: thread level 1=  1, thread level 2= 0, on nid00011. (core affinity = 32)
Hello from level 2: thread level 1=  1, thread level 2= 1, on nid00011. (core affinity = 1)
Hello from level 2: thread level 1=  1, thread level 2= 2, on nid00011. (core affinity = 33)
Hello from level 2: thread level 1=  2, thread level 2= 0, on nid00011. (core affinity = 1)
Hello from level 2: thread level 1=  2, thread level 2= 1, on nid00011. (core affinity = 33)
Hello from level 2: thread level 1=  2, thread level 2= 2, on nid00011. (core affinity = 2)
Hello from level 2: thread level 1=  3, thread level 2= 0, on nid00011. (core affinity = 33)
Hello from level 2: thread level 1=  3, thread level 2= 1, on nid00011. (core affinity = 2)
Hello from level 2: thread level 1=  3, thread level 2= 2, on nid00011. (core affinity = 34)

% export OMP_NUM_THREADS=4
% export OMP_PROC_BIND=spread
% export OMP_PLACES=threads
% srun -n 4 ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on nid00597. (core affinity = 0)
Hello from rank 0, thread 1, on nid00597. (core affinity = 8)
Hello from rank 0, thread 2, on nid00597. (core affinity = 16)
Hello from rank 0, thread 3, on nid00597. (core affinity = 24)
Hello from rank 1, thread 0, on nid00597. (core affinity = 0)
Hello from rank 1, thread 1, on nid00597. (core affinity = 8)
Hello from rank 1, thread 2, on nid00597. (core affinity = 16)
Hello from rank 1, thread 3, on nid00597. (core affinity = 24)
Hello from rank 2, thread 0, on nid00597. (core affinity = 0)
Hello from rank 2, thread 1, on nid00597. (core affinity = 8)
Hello from rank 2, thread 2, on nid00597. (core affinity = 16)
Hello from rank 2, thread 3, on nid00597. (core affinity = 24)
Hello from rank 3, thread 0, on nid00597. (core affinity = 0)
Hello from rank 3, thread 1, on nid00597. (core affinity = 8)
Hello from rank 3, thread 2, on nid00597. (core affinity = 16)
Hello from rank 3, thread 3, on nid00597. (core affinity = 24)
% srun -n 4 -c 16 --cpu_bind=cores ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on nid00597. (core affinity = 0)
Hello from rank 0, thread 1, on nid00597. (core affinity = 2)
Hello from rank 0, thread 2, on nid00597. (core affinity = 4)
Hello from rank 0, thread 3, on nid00597. (core affinity = 6)
Hello from rank 1, thread 0, on nid00597. (core affinity = 16)
Hello from rank 1, thread 1, on nid00597. (core affinity = 18)
Hello from rank 1, thread 2, on nid00597. (core affinity = 20)
Hello from rank 1, thread 3, on nid00597. (core affinity = 22)
Hello from rank 2, thread 0, on nid00597. (core affinity = 8)
Hello from rank 2, thread 1, on nid00597. (core affinity = 10)
Hello from rank 2, thread 2, on nid00597. (core affinity = 12)
Hello from rank 2, thread 3, on nid00597. (core affinity = 14)
Hello from rank 3, thread 0, on nid00597. (core affinity = 24)
Hello from rank 3, thread 1, on nid00597. (core affinity = 26)
Hello from rank 3, thread 2, on nid00597. (core affinity = 28)
Hello from rank 3, thread 3, on nid00597. (core affinity = 30)


nid00011% exit

3. Use BlueWaters AMD compute nodes

3.1 Compile

To compile, from a login node. The default is Cray compiler.
% cc -o xthi-omp xthi-omp.c
% cc -o xthi-nested-omp xthi-nested-omp.c
% cc -o xthi xthi.c

To compile with PGI compiler:
% module swap PrgEnv-cray PrgEnv-pgi
% cc -mp=nonuma -o xthi-omp xthi-omp.c
% cc -mp=nonuma -o xthi-nested-omp xthi-nested-omp.c
% cc -mp=nonuma -o xthi xthi.c

To compile with GNU compiler:
% module swap PrgEnv-cray PrgEnv-gnu
% cc -fopenmp -o xthi-omp xthi-omp.c
% cc -fopenmp -o xthi-nested-omp xthi-nested-omp.c
% cc -fopenmp -o xthi xthi.c

To compile with Intel compiler:
% module swap PrgEnv-cray PrgEnv-intel
% cc -qopenmp o xthi-omp xthi-omp.c
% cc -qopenmp o xthi-nested-omp xthi-nested-omp.c
% cc -qopenmp o xthi xthi.c

3.2 Request a compute node via interactive batch:

% qsub -I -l nodes=1:ppn=32 -q high -l walltime=1:00:00
Job submitted to account: bako
qsub: waiting for job 6963723.bw to start
<you will get on a service node, or so called a MOM node>
% 


3.3 Check NUMA and hardware configuration
Continue in the above interactive batch session, from the service node.

% aprun -n 1 numactl -H
available: 4 nodes (0-3)
node 0 cpus: 0 1 2 3 4 5 6 7
node 0 size: 16383 MB
node 0 free: 15736 MB
node 1 cpus: 8 9 10 11 12 13 14 15
node 1 size: 16384 MB
node 1 free: 14844 MB
node 2 cpus: 16 17 18 19 20 21 22 23
node 2 size: 16384 MB
node 2 free: 15391 MB
node 3 cpus: 24 25 26 27 28 29 30 31
node 3 size: 16384 MB
node 3 free: 15550 MB
node distances:
node   0   1   2   3 
  0:  10  13  13  13 
  1:  13  10  13  13 
  2:  13  13  10  13 
  3:  13  13  13  10 
Application 57100600 resources: utime ~0s, stime ~1s, Rss ~21624, inblocks ~51, outblocks ~56

Notice: you did not do "numactl -H" directly, since you will get the info 
on the service node. Instead, use "aprun -n 1 numactl -H" to run the numactl 
on a compute node.

3.4 Run

% cd $PBS_O_WORKDIR

Notice, aprun -n 1 (where "-n 1" means 1 MPI task) is needed to launch even a serial 
or a pure OpenMP job, otherwise the job will run on a service node. 

Also for pure OpenMP jobs, need to use -d xxx and -cc none options, where xxx is the 
number of threads. 

% export OMP_NUM_THREADS=8
% aprun -n 1 -d 8 -cc none ./xthi-omp |sort -k4
Hello from thread 0, on nid05859. (core affinity = 0)
Hello from thread 1, on nid05859. (core affinity = 1)
Hello from thread 2, on nid05859. (core affinity = 2)
Hello from thread 3, on nid05859. (core affinity = 3)
Hello from thread 4, on nid05859. (core affinity = 4)
Hello from thread 5, on nid05859. (core affinity = 5)
Hello from thread 6, on nid05859. (core affinity = 6)
Hello from thread 7, on nid05859. (core affinity = 7)

% export OMP_PROC_BIND=spread
% export OMP_PLACES=cores    
% aprun -N 1 -n 1 -d 8 -cc none ./xthi-omp |sort -k4
Hello from thread 0, on nid05859. (core affinity = 0)
Hello from thread 1, on nid05859. (core affinity = 4)
Hello from thread 2, on nid05859. (core affinity = 8)
Hello from thread 3, on nid05859. (core affinity = 12)
Hello from thread 4, on nid05859. (core affinity = 16)
Hello from thread 5, on nid05859. (core affinity = 20)
Hello from thread 6, on nid05859. (core affinity = 24)
Hello from thread 7, on nid05859. (core affinity = 28)

% export OMP_PROC_BIND=close 
% aprun -N 1 -n 1 -d 8 -cc none ./xthi-omp |sort -k4
Hello from thread 0, on nid05859. (core affinity = 0)
Hello from thread 1, on nid05859. (core affinity = 1)
Hello from thread 2, on nid05859. (core affinity = 2)
Hello from thread 3, on nid05859. (core affinity = 3)
Hello from thread 4, on nid05859. (core affinity = 4)
Hello from thread 5, on nid05859. (core affinity = 5)
Hello from thread 6, on nid05859. (core affinity = 6)
Hello from thread 7, on nid05859. (core affinity = 7)

% export OMP_NUM_THREADS=4,3
% export OMP_NESTED=true
% export OMP_MAX_ACTIVE_LEVELS=2

% export OMP_PROC_BIND=spread,close
% aprun -N 1 -n 1 -d 12 -cc none ./xthi-nested-omp |sort -k4
Hello from level 1: thread level 1= 0, on nid05859. (core affinity = 0,1)
Hello from level 1: thread level 1= 1, on nid05859. (core affinity = 8,9)
Hello from level 1: thread level 1= 2, on nid05859. (core affinity = 16,17)
Hello from level 1: thread level 1= 3, on nid05859. (core affinity = 24,25)
Hello from level 2: thread level 1=  0, thread level 2= 0, on nid05859. (core affinity = 0,1)
Hello from level 2: thread level 1=  0, thread level 2= 1, on nid05859. (core affinity = 2,3)
Hello from level 2: thread level 1=  0, thread level 2= 2, on nid05859. (core affinity = 4,5)
Hello from level 2: thread level 1=  1, thread level 2= 0, on nid05859. (core affinity = 8,9)
Hello from level 2: thread level 1=  1, thread level 2= 1, on nid05859. (core affinity = 10,11)
Hello from level 2: thread level 1=  1, thread level 2= 2, on nid05859. (core affinity = 12,13)
Hello from level 2: thread level 1=  2, thread level 2= 0, on nid05859. (core affinity = 16,17)
Hello from level 2: thread level 1=  2, thread level 2= 1, on nid05859. (core affinity = 18,19)
Hello from level 2: thread level 1=  2, thread level 2= 2, on nid05859. (core affinity = 20,21)
Hello from level 2: thread level 1=  3, thread level 2= 0, on nid05859. (core affinity = 24,25)
Hello from level 2: thread level 1=  3, thread level 2= 1, on nid05859. (core affinity = 26,27)
Hello from level 2: thread level 1=  3, thread level 2= 2, on nid05859. (core affinity = 28,29)

% export OMP_PROC_BIND=close,close 
% aprun -N 1 -n 1 -d 12 -cc none ./xthi-nested-omp |sort -k4
Hello from level 1: thread level 1= 0, on nid05859. (core affinity = 0,1)
Hello from level 1: thread level 1= 1, on nid05859. (core affinity = 2,3)
Hello from level 1: thread level 1= 2, on nid05859. (core affinity = 4,5)
Hello from level 1: thread level 1= 3, on nid05859. (core affinity = 6,7)
Hello from level 2: thread level 1=  0, thread level 2= 0, on nid05859. (core affinity = 0,1)
Hello from level 2: thread level 1=  0, thread level 2= 1, on nid05859. (core affinity = 2,3)
Hello from level 2: thread level 1=  0, thread level 2= 2, on nid05859. (core affinity = 4,5)
Hello from level 2: thread level 1=  1, thread level 2= 0, on nid05859. (core affinity = 2,3)
Hello from level 2: thread level 1=  1, thread level 2= 1, on nid05859. (core affinity = 4,5)
Hello from level 2: thread level 1=  1, thread level 2= 2, on nid05859. (core affinity = 6,7)
Hello from level 2: thread level 1=  2, thread level 2= 0, on nid05859. (core affinity = 4,5)
Hello from level 2: thread level 1=  2, thread level 2= 1, on nid05859. (core affinity = 6,7)
Hello from level 2: thread level 1=  2, thread level 2= 2, on nid05859. (core affinity = 8,9)
Hello from level 2: thread level 1=  3, thread level 2= 0, on nid05859. (core affinity = 6,7)
Hello from level 2: thread level 1=  3, thread level 2= 1, on nid05859. (core affinity = 8,9)
Hello from level 2: thread level 1=  3, thread level 2= 2, on nid05859. (core affinity = 10,11)

% export OMP_NUM_THREADS=4
% aprun -n 4  -d 4 ./xthi |sort -k4n,6n
Application 57248556 resources: utime ~0s, stime ~1s, Rss ~9312, inblocks ~7687, outblocks ~18240
Hello from rank 0, thread 0, on nid19708. (core affinity = 0)
Hello from rank 0, thread 1, on nid19708. (core affinity = 1)
Hello from rank 0, thread 2, on nid19708. (core affinity = 2)
Hello from rank 0, thread 3, on nid19708. (core affinity = 3)
Hello from rank 1, thread 0, on nid19708. (core affinity = 4)
Hello from rank 1, thread 1, on nid19708. (core affinity = 5)
Hello from rank 1, thread 2, on nid19708. (core affinity = 6)
Hello from rank 1, thread 3, on nid19708. (core affinity = 7)
Hello from rank 2, thread 0, on nid19708. (core affinity = 8)
Hello from rank 2, thread 1, on nid19708. (core affinity = 9)
Hello from rank 2, thread 2, on nid19708. (core affinity = 10)
Hello from rank 2, thread 3, on nid19708. (core affinity = 11)
Hello from rank 3, thread 0, on nid19708. (core affinity = 12)
Hello from rank 3, thread 1, on nid19708. (core affinity = 13)
Hello from rank 3, thread 2, on nid19708. (core affinity = 14)
Hello from rank 3, thread 3, on nid19708. (core affinity = 15)

% aprun -n 4 -S 1 -d 4 ./xthi |sort -k4n,6n
Application 57248560 resources: utime ~0s, stime ~1s, Rss ~9312, inblocks ~7687, outblocks ~18240
Hello from rank 0, thread 0, on nid19708. (core affinity = 0)
Hello from rank 0, thread 1, on nid19708. (core affinity = 1)
Hello from rank 0, thread 2, on nid19708. (core affinity = 2)
Hello from rank 0, thread 3, on nid19708. (core affinity = 3)
Hello from rank 1, thread 0, on nid19708. (core affinity = 8)
Hello from rank 1, thread 1, on nid19708. (core affinity = 9)
Hello from rank 1, thread 2, on nid19708. (core affinity = 10)
Hello from rank 1, thread 3, on nid19708. (core affinity = 11)
Hello from rank 2, thread 0, on nid19708. (core affinity = 16)
Hello from rank 2, thread 1, on nid19708. (core affinity = 17)
Hello from rank 2, thread 2, on nid19708. (core affinity = 18)
Hello from rank 2, thread 3, on nid19708. (core affinity = 19)
Hello from rank 3, thread 0, on nid19708. (core affinity = 24)
Hello from rank 3, thread 1, on nid19708. (core affinity = 25)
Hello from rank 3, thread 2, on nid19708. (core affinity = 26)
Hello from rank 3, thread 3, on nid19708. (core affinity = 27)

% aprun -n 4 -S 1 -d 4 -cc depth ./xthi |sort -k4n,6n
Application 57248562 resources: utime ~0s, stime ~1s, Rss ~9312, inblocks ~7687, outblocks ~18240
Hello from rank 0, thread 0, on nid19708. (core affinity = 0-3)
Hello from rank 0, thread 1, on nid19708. (core affinity = 0-3)
Hello from rank 0, thread 2, on nid19708. (core affinity = 0-3)
Hello from rank 0, thread 3, on nid19708. (core affinity = 0-3)
Hello from rank 1, thread 0, on nid19708. (core affinity = 8-11)
Hello from rank 1, thread 1, on nid19708. (core affinity = 8-11)
Hello from rank 1, thread 2, on nid19708. (core affinity = 8-11)
Hello from rank 1, thread 3, on nid19708. (core affinity = 8-11)
Hello from rank 2, thread 0, on nid19708. (core affinity = 16-19)
Hello from rank 2, thread 1, on nid19708. (core affinity = 16-19)
Hello from rank 2, thread 2, on nid19708. (core affinity = 16-19)
Hello from rank 2, thread 3, on nid19708. (core affinity = 16-19)
Hello from rank 3, thread 0, on nid19708. (core affinity = 24-27)
Hello from rank 3, thread 1, on nid19708. (core affinity = 24-27)
Hello from rank 3, thread 2, on nid19708. (core affinity = 24-27)
Hello from rank 3, thread 3, on nid19708. (core affinity = 24-27)

% exit

4. Use Cori KNL compute nodes

4.1 Compile
You could only compile on a Haswell login node for KNL compute nodes.

To compile, from a Haswell login node:
Make sure to do the following step first:
% module swap craype-haswell craype-mic-knl
Then
% cc -qopenmp -o xthi-omp xthi-omp.c
% cc -qopenmp -o xthi-nested-omp xthi-nested-omp.c
% cc -qopenmp -o xthi xthi.c

4.2 Request a KNL compute node
% salloc -N 1 -C knl,quad,cache -p debug -t 30:00
(or % salloc -N 1 -C knl,quad,flat -p debug -t 30:00
or % salloc -N 1 -C knl,snc2,cache -p debug -t 30:00
or % salloc -N 1 -C knl,snc2,flat -p debug -t 30:00)
...
You will then get on a KNL compute node.

4.3 Check NUMA and hardware configuration

4.3.1 68-core Quad Cache node:
NUMA Domain 0: all 68 cores (272 logic cores)
% numactl -H
available: 1 nodes (0)
node 0 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
node 0 size: 96762 MB
node 0 free: 93067 MB
node distances:
node 0
0: 10

quad,cache node has 1 NUMA domain1.  All CPUs on NUMA domains 0 (DDR memory), 
MCDRAM appears as cache only.

4.3.2 68-core Quad Flat node:
NUMA Domain 0: all 68 cores (272 logic cores)
NUMA Domain 1: HBM with no CPUs
% numactl -H
available: 2 nodes (0-1)
node 0 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
node 0 size: 96723 MB
node 0 free: 93924 MB
node 1 cpus:
node 1 size: 16157 MB
node 1 free: 16088 MB
node distances:
node 0 1
0: 10 31
1: 31 10

quad,flat node has 2 NUMA domains.  All CPUs on NUMA domains 0 (DDR memory). 
NUMA node 1 has MCDRAM only.

4.3.3 68-core SNC2 Flat node:
NUMA Domain 0: all 68 cores (272 logic cores)
NUMA Domain 1: HBM with no CPUs
% numactl -H
numactl -H
available: 4 nodes (0-3)
node 0 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237
node 0 size: 48293 MB
node 0 free: 46047 MB
node 1 cpus: 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
node 1 size: 48466 MB
node 1 free: 44949 MB
node 2 cpus:
node 2 size: 8079 MB
node2free:7983MB
node 3 cpus:
node 3 size: 8077 MB
node 3 free: 7980 MB
node distances:
node   0   1   2   3 
  0:  10  21  31  41 
  1:  21  10  41  31 
  2:  31  41  10  41 
  3:  41  31  41  10 

snc2,flat node has 4 NUMA domains.  All CPUs on NUMA domains 0 and 1 (DDR memory), 
each has half of the CPUs. NUMA nodes 2 and 3 have MCDRAM only.


4.4 Run 
% export OMP_NUM_THREADS=8
% export OMP_PROC_BIND=spread
% export OMP_PLACES=cores
% ./xthi-omp |sort -k6n
Hello from thread 0, on nid02304. (core affinity = 0,68,136,204)
Hello from thread 1, on nid02304. (core affinity = 9,77,145,213)
Hello from thread 2, on nid02304. (core affinity = 17,85,153,221)
Hello from thread 3, on nid02304. (core affinity = 26,94,162,230)
Hello from thread 4, on nid02304. (core affinity = 34,102,170,238)
Hello from thread 5, on nid02304. (core affinity = 43,111,179,247)
Hello from thread 6, on nid02304. (core affinity = 51,119,187,255)
Hello from thread 7, on nid02304. (core affinity = 60,128,196,264)

% export OMP_PROC_BIND=close 
% ./xthi-omp |sort -k6n
Hello from thread 0, on nid02304. (core affinity = 0,68,136,204)
Hello from thread 1, on nid02304. (core affinity = 1,69,137,205)
Hello from thread 2, on nid02304. (core affinity = 2,70,138,206)
Hello from thread 3, on nid02304. (core affinity = 3,71,139,207)
Hello from thread 4, on nid02304. (core affinity = 4,72,140,208)
Hello from thread 5, on nid02304. (core affinity = 5,73,141,209)
Hello from thread 6, on nid02304. (core affinity = 6,74,142,210)
Hello from thread 7, on nid02304. (core affinity = 7,75,143,211)
% export OMP_PLACES=threads
% ./xthi-omp |sort -k6n
Hello from thread 0, on nid02304. (core affinity = 0)
Hello from thread 1, on nid02304. (core affinity = 68)
Hello from thread 2, on nid02304. (core affinity = 136)
Hello from thread 3, on nid02304. (core affinity = 204)
Hello from thread 4, on nid02304. (core affinity = 1)
Hello from thread 5, on nid02304. (core affinity = 69)
Hello from thread 6, on nid02304. (core affinity = 137)
Hello from thread 7, on nid02304. (core affinity = 205)
% export OMP_PROC_BIND=spread
% ./xthi-omp |sort -k6n
Hello from thread 0, on nid02304. (core affinity = 0)
Hello from thread 1, on nid02304. (core affinity = 144)
Hello from thread 2, on nid02304. (core affinity = 17)
Hello from thread 3, on nid02304. (core affinity = 161)
Hello from thread 4, on nid02304. (core affinity = 34)
Hello from thread 5, on nid02304. (core affinity = 178)
Hello from thread 6, on nid02304. (core affinity = 51)
Hello from thread 7, on nid02304. (core affinity = 195)

Now with the hybrid MPI/OpenMP "xthi.c" code:
% export OMP_NUM_THREADS=4
% export OMP_PROC_BIND=spread
% export OMP_PLACES=threads
% srun -n 4  ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on nid06509. (core affinity = 0)
Hello from rank 0, thread 1, on nid06509. (core affinity = 17)
Hello from rank 0, thread 2, on nid06509. (core affinity = 34)
Hello from rank 0, thread 3, on nid06509. (core affinity = 51)
Hello from rank 1, thread 0, on nid06509. (core affinity = 0)
Hello from rank 1, thread 1, on nid06509. (core affinity = 17)
Hello from rank 1, thread 2, on nid06509. (core affinity = 34)
Hello from rank 1, thread 3, on nid06509. (core affinity = 51)
Hello from rank 2, thread 0, on nid06509. (core affinity = 0)
Hello from rank 2, thread 1, on nid06509. (core affinity = 17)
Hello from rank 2, thread 2, on nid06509. (core affinity = 34)
Hello from rank 2, thread 3, on nid06509. (core affinity = 51)
Hello from rank 3, thread 0, on nid06509. (core affinity = 0)
Hello from rank 3, thread 1, on nid06509. (core affinity = 17)
Hello from rank 3, thread 2, on nid06509. (core affinity = 34)
Hello from rank 3, thread 3, on nid06509. (core affinity = 51)

The "-c xxx --cpu_bind=cores" flags are essential:
% srun -n 4 -c 64  --cpu_bind=cores ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on nid06509. (core affinity = 0)
Hello from rank 0, thread 1, on nid06509. (core affinity = 4)
Hello from rank 0, thread 2, on nid06509. (core affinity = 8)
Hello from rank 0, thread 3, on nid06509. (core affinity = 12)
Hello from rank 1, thread 0, on nid06509. (core affinity = 16)
Hello from rank 1, thread 1, on nid06509. (core affinity = 20)
Hello from rank 1, thread 2, on nid06509. (core affinity = 24)
Hello from rank 1, thread 3, on nid06509. (core affinity = 28)
Hello from rank 2, thread 0, on nid06509. (core affinity = 32)
Hello from rank 2, thread 1, on nid06509. (core affinity = 36)
Hello from rank 2, thread 2, on nid06509. (core affinity = 40)
Hello from rank 2, thread 3, on nid06509. (core affinity = 44)
Hello from rank 3, thread 0, on nid06509. (core affinity = 48)
Hello from rank 3, thread 1, on nid06509. (core affinity = 52)
Hello from rank 3, thread 2, on nid06509. (core affinity = 56)
Hello from rank 3, thread 3, on nid06509. (core affinity = 60)
% exit

Running on a KNL Quad Flat node is similar to running on a KNL Quad Cache node
on Cori. Except you will request a compute node with
% salloc -N 1 -C knl,quad,flat -p debug -t 30:00
And you will run your executable with numactl to use MCDRAM
% numactl -m 1 ./xthi-omp   (if use memory < 16 GB)
or
% numactl -p 1 ./xthi-omp    (if use memory > 16 GB)


And for SNC2 Flat mode, you will request a node with
% salloc -N 1 -C snc2,quad,flat -p debug -t 30:00
And you will run your executable with numactl to use MCDRAM:
% numactl -m 2,3 ./xthi-omp   (if use memory < 16 GB)
or
% numactl -p 2,3 ./xthi-omp   (if use memory < 16 GB)


5. Use TACC KNL compute nodes
% cd $WORK
% module list

Currently Loaded Modules:
  1) intel/17.0.4   2) impi/17.0.3   3) git/2.9.0   4) autotools/1.1   
  5) python/2.7.13   6) xalt/1.7   7) TACC

5.1 Compile

To compile, from a login node. 

$ icc -qopenmp -xCORE-AVX2 -o xthi-omp xthi-omp.c
$ icc -qopenmp -xCORE-AVX2 -o xthi-nested-omp xthi-nested-omp.c
$ mpiicc -qopenmp -xCORE-AVX2 -o xthi xthi.c

5.2 Request a compute node via interactive batch 
(it includes 5.3 Check NUMA and hardware configuration) 

login4.stampede2(47)$ idev

 -> Compute nodes in the development queue of the stampede2 system have HyperThreading turned on.
 -> Normal HPC Applications will use no more than 68 tasks per node (=cores/node).
 -> Few Apps use all HyperThreads [4 (HWthreads/Core) x 68 (Cores/Node) = 272 ).
 -> FOR IDEV USE: specify the default tasks/per node for this queue.(68 suggested)
Please type the tasks per node and hit return: 1
 -> 1 is the number of tasks per node selected for the development queue.


We need a project to charge for interactive use.
for a Single Project : We store "use_default"              in the $HOME/.idevrc file.
for Multiple Projects: We will store your selected project in the $HOME/.idevrc file.

 You have a single project which we will use as the default.
 -> Defaults file    : ~/.idevrc   
 -> System           : stampede2   
 -> Nodes            : 1             (idev  default       )
 -> Tasks per Node   : 1             (~/.idevrc           )
 -> Project          : (use_default  (SLURM default       )

-----------------------------------------------------------------
          Welcome to the Stampede 2 Supercomputer          
-----------------------------------------------------------------

No reservation for this job
--> Verifying valid submit host (login4)...OK
--> Verifying valid jobname...OK
--> Enforcing max jobs per user...OK
--> Verifying availability of your home dir (/home1/04174/yunhe)...OK
--> Verifying availability of your work dir (/work/04174/yunhe/stampede2)...OK
--> Verifying availability of your scratch dir (/scratch/04174/yunhe)...OK
--> Verifying valid ssh keys...OK
--> Verifying access to desired queue (development)...OK
--> Verifying job request is within current queue limits...OK
--> Checking available allocation (StampedeNERSC)...OK
Submitted batch job 52992

 -> After your idev job begins to run, a command prompt will appear,
 -> and you can begin your interactive development session. 
 -> We will report the job status every 4 seconds: (PD=pending, R=running).

 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  PD
 ->job status:  R

 -> Job is now running on masternode= c401-094...OK
 -> Sleeping for 7 seconds...OK
 -> Checking to make sure your job has initialized an env for you....OK
 -> Creating interactive terminal session (login) on master node c401-094.

TACC Stampede2 System
Provisioned on 08-May-2017 at 13:27
 
c401-094.stampede2(1)$ numactl -H
available: 1 nodes (0)
node 0 cpus: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
node 0 size: 98199 MB
node 0 free: 90861 MB
node distances:
node   0 
  0:  10 

c401-094.stampede2(2)$ 
c401-094.stampede2(2)$ export OMP_NUM_THREADS=8
c401-094.stampede2(3)$ ./xthi-omp |sort -k6n
Hello
Hello from thread 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0)
Hello from thread 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 1)
Hello from thread 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 2)
Hello from thread 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 3)
Hello from thread 4, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 4)
Hello from thread 5, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 5)
Hello from thread 6, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 6)
Hello from thread 7, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 7)
c401-094.stampede2(4)$ 
c401-094.stampede2(4)$ export OMP_PROC_BIND=spread
c401-094.stampede2(5)$ export OMP_PLACES=cores
c401-094.stampede2(6)$ ./xthi-omp |sort -k6n
Hello from thread 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0,68,136,204)
Hello from thread 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 9,77,145,213)
Hello from thread 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 17,85,153,221)
Hello from thread 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 26,94,162,230)
Hello from thread 4, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 34,102,170,238)
Hello from thread 5, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 43,111,179,247)
Hello from thread 6, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 51,119,187,255)
Hello from thread 7, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 60,128,196,264)
c401-094.stampede2(7)$ 
c401-094.stampede2(7)$ export OMP_PLACES=threads
c401-094.stampede2(8)$ ./xthi-omp |sort -k6n
Hello from thread 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0)
Hello from thread 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 144)
Hello from thread 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 17)
Hello from thread 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 161)
Hello from thread 4, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 34)
Hello from thread 5, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 178)
Hello from thread 6, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 51)
Hello from thread 7, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 195)
c401-094.stampede2(9)$ 
c401-094.stampede2(9)$ export OMP_PROC_BIND=close
c401-094.stampede2(10)$ ./xthi-omp |sort -k6n
Hello from thread 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0)
Hello from thread 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 68)
Hello from thread 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 136)
Hello from thread 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 204)
Hello from thread 4, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 1)
Hello from thread 5, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 69)
Hello from thread 6, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 137)
Hello from thread 7, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 205)
c401-094.stampede2(11)$ 
c401-094.stampede2(13)$ export OMP_PLACES=cores
c401-094.stampede2(14)$ ./xthi-omp |sort -k6n
Hello from thread 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0,68,136,204)
Hello from thread 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 1,69,137,205)
Hello from thread 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 2,70,138,206)
Hello from thread 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 3,71,139,207)
Hello from thread 4, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 4,72,140,208)
Hello from thread 5, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 5,73,141,209)
Hello from thread 6, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 6,74,142,210)
Hello from thread 7, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 7,75,143,211)
c401-094.stampede2(15)$ 


Nested OpenMP:
c401-094.stampede2(15)$ 
c401-094.stampede2(15)$ export OMP_NUM_THREADS=4,3
c401-094.stampede2(16)$ export OMP_NESTED=true
c401-094.stampede2(17)$ export OMP_MAX_ACTIVE_LEVELS=2
c401-094.stampede2(18)$ 
c401-094.stampede2(18)$ 
c401-094.stampede2(18)$ export OMP_PROC_BIND=spread,close
c401-094.stampede2(19)$ export OMP_PLACES=cores
c401-094.stampede2(20)$ ./xthi-nested-omp |sort -k6n
Hello from level 1: thread level 1= 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0,68,136,204)
Hello from level 1: thread level 1= 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 17,85,153,221)
Hello from level 1: thread level 1= 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 34,102,170,238)
Hello from level 1: thread level 1= 3, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 51,119,187,255)
Hello from level 2: thread level 1=  0, thread level 2= 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 0,68,136,204)
Hello from level 2: thread level 1=  0, thread level 2= 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 1,69,137,205)
Hello from level 2: thread level 1=  0, thread level 2= 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 2,70,138,206)
Hello from level 2: thread level 1=  1, thread level 2= 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 17,85,153,221)
Hello from level 2: thread level 1=  1, thread level 2= 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 18,86,154,222)
Hello from level 2: thread level 1=  1, thread level 2= 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 19,87,155,223)
Hello from level 2: thread level 1=  2, thread level 2= 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 34,102,170,238)
Hello from level 2: thread level 1=  2, thread level 2= 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 35,103,171,239)
Hello from level 2: thread level 1=  2, thread level 2= 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 36,104,172,240)
Hello from level 2: thread level 1=  3, thread level 2= 0, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 51,119,187,255)
Hello from level 2: thread level 1=  3, thread level 2= 1, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 52,120,188,256)
Hello from level 2: thread level 1=  3, thread level 2= 2, on c401-094.stampede2.tacc.utexas.edu. (core affinity = 53,121,189,257)
c401-094.stampede2(21)$ 


To request a quad,flat node on Stampede2, do
% idev -p flat-quadrant
And at run time, use numactl to use MCDRAM
% numactl -m 1 ./xthi-omp   (if use memory < 16 GB)
or
% numactl -p 1 ./xthi-omp    (if use memory > 16 GB)

To request a xnc4,flat node on Stampede2, do
% idev -p flat-snc4
And at run time, use numactl to use MCDRAM
% numactl -m 4,5,6,7 ./xthi-omp   (if use memory < 16 GB)
or
% numactl -p 4,5,6,7 ./xthi-omp    (if use memory > 16 GB)


Hybrid MPI/OpenMP:
Sample outputs with 16 MPI tasks x 8 OpenMP threads per task 
on a single 68-core stampede2 KNL quad,cache node using mpirun 
(binary built with Intel MPI).

% export OMP_NUM_THREADS=8
% export OMP_PROC_BIND=spread    
% export OMP_PLACES=threads      

% mpirun -n 16  ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on cc10. (core affinity = 0)
Hello from rank 0, thread 1, on cc10. (core affinity = 204)
Hello from rank 0, thread 2, on cc10. (core affinity = 69)
Hello from rank 0, thread 3, on cc10. (core affinity = 205)
Hello from rank 0, thread 4, on cc10. (core affinity = 70)
Hello from rank 0, thread 5, on cc10. (core affinity = 206)
Hello from rank 0, thread 6, on cc10. (core affinity = 71)
Hello from rank 0, thread 7, on cc10. (core affinity = 207)
Hello from rank 1, thread 0, on cc10. (core affinity = 72)
Hello from rank 1, thread 1, on cc10. (core affinity = 5)
...

% export I_MPI_PIN_DOMAIN=16
% mpirun -n 16 ./xthi |sort -k4n,6n
Hello from rank 0, thread 0, on cc10. (core affinity = 0)
Hello from rank 0, thread 1, on cc10. (core affinity = 136)
Hello from rank 0, thread 2, on cc10. (core affinity = 1)
Hello from rank 0, thread 3, on cc10. (core affinity = 137)
Hello from rank 0, thread 4, on cc10. (core affinity = 2)
Hello from rank 0, thread 5, on cc10. (core affinity = 138)
Hello from rank 0, thread 6, on cc10. (core affinity = 3)
Hello from rank 0, thread 7, on cc10. (core affinity = 139)
Hello from rank 1, thread 0, on cc10. (core affinity = 4)
Hello from rank 1, thread 1, on cc10. (core affinity = 140)
...

== Description ==
A more complex version of simple synchronization example. Different
ways to solve the prolem is provided in different version of the solution.

== How to do the exercises ==

c_exercise_bank_account.c file contains the exercise, please open the the exercise file, modify it with OpenMP pragma and runtime routines.

[Solution files are also provided. They follow the naming convention *_solution_*.]

== Compilation and running on the training machines with training accounts ==

=== Compilation ===

source build_job.sh <compiler name (cray, intel, gnu, pgi)>

e.g. source build_job.sh cray

=== Running ===

Batch mode(easy to do, same command will work for all machines)
---------------------------------------------------------------
    source run_job.sh <executable name>

    e.g. source run_job.sh c_exercise_bank_account.x 
    
Interactive mode (a bit more work, but more useful for development and testing)
-------------------------------------------------------------------
    For Blue Waters:
    ----------------
    1. Allocate a compute node for 1 hour,
        qsub -I -l nodes=1:ppn=32:xe -l walltime=01:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_bank_account.x
    For Cori:
    ---------
    1. Allocate a haswell compute node for 1 hour,
        salloc -N 1 -C haswell -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_bank_account.x
    For Edison:
    -----------
    1. Allocate a compute node for 1 hour,
        salloc -N 1 -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_bank_account.x
    For Stampede2:
    --------------
    1. Allocate a KNL compute node for 1 hour,
        idev -p normal -N 1 -n 68 -m 60
    2. Once allocated, run the program like any executable
        ./c_exercise_bank_account.x

====================================================================================

== Compilation and running on other machines or with different accounts ==

=== Compilation ===

make compiler=<comiler name (cray, intel, gnu, pgi)>
e.g. make comiler=cray

=== Running ===

./<executable name>

e.g. ./c_exercise_bank_account.x

== Description ==
This example illustrates a very simple race condition and demonstrates
how to address it in OpenMP. Consider a bank account, to which
multiple debits and credits are applied concurrently.  The possible
race between read and write operations may result in account balance
inconsistency.  This race condition is then solved using OpenMP
critical section and atomic construct.

== How to do the exercises ==

*_exercise_*(e.g. c_exercise_simple_sync.c) files contain the exercises, please choose a exercise file based
on whichever programming language you are familiar with (c/c++,Fortran).
Open the exercise file, modify it with OpenMP pragma and runtime routines.

[Solution files are also provided. They follow the naming convention *_solution_*.]

== Compilation and running on the training machines with training accounts ==

=== Compilation ===

source build_job.sh <compiler name (cray, intel, gnu, pgi)>

e.g. source build_job.sh cray

=== Running ===

Batch mode(easy to do, same command will work for all machines)
---------------------------------------------------------------
    source run_job.sh <executable name>

    e.g. source run_job.sh ./c_exercise_simple_sync.x 
    
Interactive mode (a bit more work, but more useful for development and testing)
-------------------------------------------------------------------
    For Blue Waters:
    ----------------
    1. Allocate a compute node for 1 hour,
        qsub -I -l nodes=1:ppn=32:xe -l walltime=01:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_simple_sync.x
    For Cori:
    ---------
    1. Allocate a haswell compute node for 1 hour,
        salloc -N 1 -C haswell -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_simple_sync.x
    For Edison:
    -----------
    1. Allocate a compute node for 1 hour,
        salloc -N 1 -p regular -t 1:00:00
    2. Once allocated, run the program like any executable
        ./c_exercise_simple_sync.x
    For Stampede2:
    --------------
    1. Allocate a KNL compute node for 1 hour,
        idev -p normal -N 1 -n 68 -m 60
    2. Once allocated, run the program like any executable
        ./c_exercise_simple_sync.x
        
====================================================================================


== Compilation and running on other machines or with different accounts ==

=== Compilation ===

make compiler=<comiler name (cray, intel, gnu, pgi)>
e.g. make comiler=cray

=== Running ===

./<executable name>

e.g. ./c_exercise_simple_sync.x

program ba

    use omp_lib
    implicit none

    integer(8), parameter :: NUM_ACCOUNTS = 2
    integer(8), parameter :: NUM_TRANSACTION = 10
    integer(8), parameter :: INIT_BALANCE = 0
    integer(8), dimension(0:NUM_TRANSACTION - 1), parameter :: transaction = (/&
    &               10, 20, 30, -40, -50, 80, -10, -50, 100, 90  &
    &             /)
    integer(8), dimension(0:NUM_ACCOUNTS - 1)   :: balance = (INIT_BALANCE, INIT_BALANCE)
    integer(8), dimension(0:NUM_ACCOUNTS - 1)   :: balance_ser = (INIT_BALANCE, INIT_BALANCE)

    integer(8)            :: i
    double precision      :: start_time, final_time


    ! This part of the code is run in serial to get the correct result.
    ! We will use this result to check with our multithreaded solution.
    ! even indexed (including 0) transaction goes to account 0,
    ! odd indexed transaction goes to account 1

    do i = 0, NUM_TRANSACTION - 1
        balance_ser(mod(i, 2)) = balance_ser(mod(i, 2)) + transaction(i)
    end do

    start_time = omp_get_wtime()

    ! Parallelized version
    ! @TODO: parallelize this account balance update part.
    ! Make sure the the upadate does not have race condition
    do i = 0, NUM_TRANSACTION - 1
        balance(mod(i, 2)) = balance(mod(i, 2)) + transaction(i)
    end do

    final_time = omp_get_wtime() - start_time

    write (*, '(A,f14.10)') 'Total time:  ', final_time
    write (*, *) 'Final account balance is following...'
    do i = 0, NUM_ACCOUNTS - 1
        write (*, '(A,I4,A,I4,A,I4)') 'Account No. =', i,  &
        ', actual balance =', balance(i), &
        ', correct balance should be =', balance_ser(i)
    end do

end program ba

program omp_red_black

    use omp_lib

    implicit none

    integer, parameter                  :: DSIZE_X = 10, DSIZE_Y= 5000, ITERNUM = 10000
    double precision, dimension(0:DSIZE_X-1, 0:DSIZE_Y-1)   :: grid
    double precision                    :: sum = 0.0
    double precision                    :: start_time, final_time
    integer                             :: i, j, n

    ! starting the clock
    start_time = omp_get_wtime()

    ! Parallelized this loop.
    ! Parallelization is done in the following way to benefit
    ! from Fortran coloumn major order array idexing
    !$omp parallel do private(i) schedule(static)
    do j = 0, DSIZE_Y - 1
        do i = 0, DSIZE_X - 1
            grid(i, j) = mod((i * j), 10)
        end do
    end do
    !$omp end parallel do


    ! Parallelizing the outer loop is not possible.
    ! Each iteration depends on the value of previous iteration
    ! so we will parallelize one level below

    do n = 1, ITERNUM
    !$omp parallel private(i, j)
        ! Update red points
        !$omp do schedule(static)
        do j = 1, DSIZE_Y - 2, 2
            do i = 1, DSIZE_X - 2, 2
                grid(i, j) = 0.25 * (grid(i-1, j) + grid(i+1, j) +&
                            grid(i, j-1) + grid(i, j+1))
            end do
        end do
        !$omp end do nowait

        !$omp do schedule(static)
        do j = 2, DSIZE_Y - 2, 2
            do i = 2, DSIZE_X - 2, 2
                grid(i, j) = 0.25 * (grid(i-1, j) + grid(i+1, j) +&
                            grid(i, j-1) + grid(i, j+1))
            end do
        end do
        !$omp end do

        ! Update black points

        !$omp do schedule(static)
        do j = 2, DSIZE_Y - 2, 2
            do i = 1, DSIZE_X - 2, 2
                grid(i, j) = 0.25 * (grid(i-1, j) + grid(i+1, j) +&
                            grid(i, j-1) + grid(i, j+1))
            end do
        end do
        !$omp end do nowait

        !$omp do schedule(static)
        do j = 1, DSIZE_Y - 2, 2
            do i = 2, DSIZE_X - 2, 2
                grid(i, j) = 0.25 * (grid(i-1, j) + grid(i+1, j) +&
                            grid(i, j-1) + grid(i, j+1))
            end do
        end do
        !$omp end do
    !$omp end parallel
    end do

    !$omp parallel do private(i) schedule(static) reduction(+:sum)
    do j = 0, DSIZE_Y - 1
        do i = 0, DSIZE_X - 1
            sum = sum + grid(i, j)
        end do
    end do
    !$omp end parallel do

    ! Calculating total execution time
    final_time = omp_get_wtime() - start_time;

    write (*, '(a,f14.2)') 'Sum: ', sum
    write (*, '(a,f14.6)') 'Total time:  ', final_time
    stop
end program omp_red_black

program exercise_hello_world

    ! @TODO: Include the OpenMP module

    implicit none


    ! @TODO: Insert OpenMP pragma to make the following code block parallel

    ! @TODO: Get the individual thread number in 'id'
    ! using a runtime routine
    integer :: thread_id = 0


    ! Print Hello world from each thread
    write ( *, '(a,i4)' ) 'Hello World from thread ', thread_id

    ! @TODO: Make absolutely sure each thread has printed "Hello World",
    ! before we move forward

    ! @TODO: Now get the master thread to identify itself!
    write ( *, '(a,i4)' ) 'Hi, I am MASTER, my id is always ', thread_id

    ! Now print Hello OpenMP from each thread
    ! (after all everybody needs to learn OpenMP!)
    write ( *, '(a,i4)' ) 'Hello OpenMP from thread  ', thread_id

    stop

end program exercise_hello_world

program omp_hello_world

    use omp_lib

    implicit none

    integer :: thread_id

    !$omp parallel private(thread_id)

        ! Getting the individual thread number in 'id'
        ! using a runtime routine
        thread_id = omp_get_thread_num()

        ! Print Hello world from each thread
        write ( *, '(a,i4)' ) 'Hello World from thread ', thread_id

        ! Making sure each thread has printed "Hello World",
        ! before we move forward
        !$omp barrier

        ! Making the master thread to identify itself!
        !$omp master
            write ( *, '(a,i4)' ) 'Hi, I am MASTER, my id is always ', thread_id
        !$omp end master

        ! Now print Hello OpenMP from each thread
        ! (after all everybody needs to learn OpenMP!)
        write ( *, '(a,i4)' ) 'Hello OpenMP from thread  ', thread_id

    !$omp end parallel

    stop

  end program omp_hello_world

      program main 
************************************************************
* program to solve a finite difference 
* discretization of Helmholtz equation :  
* (d2/dx2)u + (d2/dy2)u - alpha u = f 
* using Jacobi iterative method. 
*
* Modified: Sanjiv Shah,       Kuck and Associates, Inc. (KAI), 1998
* Author:   Joseph Robicheaux, Kuck and Associates, Inc. (KAI), 1998
* 
* Directives are used in this code to achieve paralleism. 
* All do loops are parallized with default 'static' scheduling.
* 
* Input :  n - grid dimension in x direction 
*          m - grid dimension in y direction
*          alpha - Helmholtz constant (always greater than 0.0)
*          tol   - error tolerance for iterative solver
*          relax - Successice over relaxation parameter
*          mits  - Maximum iterations for iterative solver
*
* On output 
*       : u(n,m) - Dependent variable (solutions)
*       : f(n,m) - Right hand side function 
*************************************************************
      implicit none 

      integer n,m,mits 
      double precision tol,relax,alpha 

      common /idat/ n,m,mits
      common /fdat/tol,alpha,relax
* 
* Read info 
* 
      write(*,*) "Input n,m - grid dimension in x,y direction " 
      read(5,*) n,m 
      write(*,*) "Input alpha - Helmholts constant " 
      read(5,*) alpha
      write(*,*) "Input relax - Successive over-relaxation parameter"
      read(5,*) relax 
      write(*,*) "Input tol - error tolerance for iterative solver" 
      read(5,*) tol 
      write(*,*) "Input mits - Maximum iterations for solver" 
      read(5,*) mits

*
* Calls a driver routine 
* 
      call driver () 

      !stop
      end 

      subroutine driver ( ) 
*************************************************************
* Subroutine driver () 
* This is where the arrays are allocated and initialzed. 
*
* Working varaibles/arrays 
*     dx  - grid spacing in x direction 
*     dy  - grid spacing in y direction 
*************************************************************
      use omp_lib

      implicit none 

      integer n,m,mits,mtemp 
      double precision tol,relax,alpha 

      common /idat/ n,m,mits,mtemp
      common /fdat/tol,alpha,relax

      double precision u(n,m),f(n,m),dx,dy

      integer nthreads, nteams

      double precision omptstart, omptend
      double precision omptotaltstart, omptotaltend
      double precision omptotaltime, ompjacobitime
      double precision ompinittime, omperrortime

!!$omp target
!!$omp teams
!!$omp parallel
!      nthreads = omp_get_num_threads()
!      nteams = omp_get_num_teams()
!!$omp end parallel
!!$omp end teams
!!$omp end target
!
!      write(*,'(A,I5,A,I5)') 'target teams parallel: threads=',
!     & nthreads, ', teams=', nteams

!$omp target
!$omp parallel
      nthreads = omp_get_num_threads()
      nteams = omp_get_num_teams()
!$omp end parallel
!$omp end target

      write(*,*) ''
      write(*,*) '-----------------------------------------------'
      write(*,'(A,I5,A,I5)') 'target parallel: threads=',
     & nthreads, ', teams=', nteams
      write(*,*) ''

!$omp parallel
      nthreads = omp_get_num_threads()
      nteams = omp_get_num_teams()
!$omp end parallel

      write(*,'(A,I5,A,I5)') 'parallel: threads=',
     & nthreads, ', teams=', nteams
      write(*,*) '-----------------------------------------------'
      write(*,*) ''

      omptotaltstart = omp_get_wtime ()

* Initialize data
      omptstart = omp_get_wtime ()
      call initialize (n,m,alpha,dx,dy,u,f)
      omptend = omp_get_wtime ()
      ompinittime = omptend - omptstart

* Solve Helmholtz equation

      omptstart = omp_get_wtime ()
      call jacobi (n,m,dx,dy,alpha,relax,u,f,tol,mits)
      omptend = omp_get_wtime ()
      ompjacobitime = omptend - omptstart

* Check error between exact solution

      omptstart = omp_get_wtime ()
      call  error_check (n,m,alpha,dx,dy,u,f)
      omptend = omp_get_wtime ()
      omperrortime = omptend - omptstart

      omptotaltend = omp_get_wtime ()
      omptotaltime = omptotaltend - omptotaltstart

      write(*,*) ''
      write(*,*) ''
      write(*,*) 'Timing statistics'
      write(*,*) '=================='
      write(*,*) 'header, ompinit, ompjacobi, omperror, omptotal'
      write(*,*) 'omp, ', ompinittime,', ', ompjacobitime,
     &', ',omperrortime,', ', omptotaltime
      write(*,100) 'ompt, ', ompinittime,', ', ompjacobitime,
     &', ',omperrortime,', ', omptotaltime
      write(*,*) ''
100   format (A,3(F12.8,A),F12.8)

      return 
      end 

      subroutine initialize (n,m,alpha,dx,dy,u,f) 
******************************************************
* Initializes data 
* Assumes exact solution is u(x,y) = (1-x^2)*(1-y^2)
*
******************************************************
      implicit none 
     
      integer n,m
      double precision u(n,m),f(n,m),dx,dy,alpha
      
      integer i,j, xx,yy
      double precision PI 
      parameter (PI=3.1415926)

      dx = 2.0 / (n-1)
      dy = 2.0 / (m-1)

* Initilize initial condition and RHS

!$omp target

!$omp parallel do private(xx,yy)
      do j = 1,m
         do i = 1,n
            xx = -1.0 + dx * dble(i-1)        ! -1 < x < 1
            yy = -1.0 + dy * dble(j-1)        ! -1 < y < 1
            u(i,j) = 0.0 
            f(i,j) = -alpha *(1.0-xx*xx)*(1.0-yy*yy) 
     &           - 2.0*(1.0-xx*xx)-2.0*(1.0-yy*yy)
         enddo
      enddo
!$omp end parallel do
!$omp end target

      return 
      end 

      subroutine jacobi (n,m,dx,dy,alpha,omega,u,f,tol,maxit)
******************************************************************
* Subroutine HelmholtzJ
* Solves poisson equation on rectangular grid assuming : 
* (1) Uniform discretization in each direction, and 
* (2) Dirichlect boundary conditions 
* 
* Jacobi method is used in this routine 
*
* Input : n,m   Number of grid points in the X/Y directions 
*         dx,dy Grid spacing in the X/Y directions 
*         alpha Helmholtz eqn. coefficient 
*         omega Relaxation factor 
*         f(n,m) Right hand side function 
*         u(n,m) Dependent variable/Solution
*         tol    Tolerance for iterative solver 
*         maxit  Maximum number of iterations 
*
* Output : u(n,m) - Solution 
*****************************************************************
      use omp_lib
      implicit none 
      integer n,m,maxit
      double precision dx,dy,f(n,m),u(n,m),alpha, tol,omega
*
* Local variables 
* 
      integer i,j,k,k_local 
      double precision error,resid,rsum,ax,ay,b,brecip
      double precision error_local, uold(n,m)

      real ta,tb,tc,td,te,ta1,ta2,tb1,tb2,tc1,tc2,td1,td2
      real te1,te2
      real second
      external second
      double precision t1, t2

*
* Initialize coefficients 
      ax = 1.0/(dx*dx) ! X-direction coef 
      ay = 1.0/(dy*dy) ! Y-direction coef
      b  = -2.0/(dx*dx)-2.0/(dy*dy) - alpha ! Central coeff  
      brecip = 1/b

      error = 0
      k = 1

      t1 = omp_get_wtime()

!$omp target data map(to:f) map(tofrom:u) map(alloc:uold)
      do while (k.le.maxit .and. (error.gt.tol .or. k .eq. 1))

         error = 0.0    

* Copy new solution into old
!$omp target
!$omp parallel

!$omp do 
         do j=1,m
            do i=1,n
               uold(i,j) = u(i,j) 
            enddo
         enddo

* Compute stencil, residual, & update

!$omp do private(resid) reduction(+:error)
         do j = 2,m-1
            do i = 2,n-1 
*     Evaluate residual 
               resid = (ax*(uold(i-1,j) + uold(i+1,j))
     &                + ay*(uold(i,j-1) + uold(i,j+1))
     &                - f(i,j))*brecip + uold(i,j)
* Update solution 
               u(i,j) = uold(i,j) - omega * resid
* Accumulate residual error
               error = error + resid*resid 
            end do
         enddo
!$omp enddo nowait

!$omp end parallel
!$omp end target

* Error check 

         k = k + 1

         error = sqrt(error)/dble(n*m)
*
      enddo                     ! End iteration loop 
!$omp end target data

      t2 = omp_get_wtime()
      k = k - 1 !---fix iteration count.
*
      print *, 'Total Number of Iterations ', k
      print *, 'Residual                   ', error
      print *, 'Walltime                   ', t2-t1
      print *, 'GF/sec                     ',
     &         m*n*k*12*1e-9/(t2-t1)
      print *, 'GB/sec                     ',
     &         m*n*k*8*9*1e-9/(t2-t1)

!---Titan/Chester per-socket mem BW: 25.6 GB/sec
!---Titan/Chester per-core max flop rate: 8.8 GF/sec

      return 
      end 

      subroutine error_check (n,m,alpha,dx,dy,u,f) 
      implicit none 
************************************************************
* Checks error between numerical and exact solution 
*
************************************************************ 
     
      integer n,m
      double precision u(n,m),f(n,m),dx,dy,alpha 
      
      integer i,j
      double precision xx,yy,temp,error 

      dx = 2.0 / (n-1)
      dy = 2.0 / (m-1)
      error = 0.0 

!$omp target
!$omp parallel do private(xx,yy,temp) reduction(+:error)
      do j = 1,m
         do i = 1,n
            xx = -1.0d0 + dx * dble(i-1)
            yy = -1.0d0 + dy * dble(j-1)
            temp  = u(i,j) - (1.0-xx*xx)*(1.0-yy*yy)
            error = error + temp*temp 
         enddo
      enddo
!$omp end parallel do
!$omp end target
  
      error = sqrt(error)/dble(n*m)

      print *, 'Solution Error             ',error

      return 
      end 

#!/bin/bash

module load gcc-5

gcc -fopenmp exemplo_06_1.c -o exemplo_06_1
gcc -fopenmp exemplo_06_1_nowait.c -o exemplo_06_1_nowait
gcc -fopenmp exemplo_06_2.c -o exemplo_06_2
gcc -fopenmp exemplo_06_3.c -o exemplo_06_3
gcc -fopenmp exemplo_06.c -o exemplo_06

echo '*** COMPILACAO COMPLETADA ***'

#!/bin/bash

module load gcc-5

gcc -fopenmp exemplo_01.c -o exemplo_01
gcc -fopenmp exemplo_01_num_threads.c -o exemplo_01_num_threads
gcc -fopenmp exemplo_01_parallel.c -o exemplo_01_parallel
gcc -fopenmp exemplo_01_set_num_threads.c -o exemplo_01_set_num_threads

echo 'COMPILACAO COMPLETADA'

#!/bin/bash

module load gcc-5

gcc -fopenmp exemplo_04_05.c -o exemplo_04_05
gcc -fopenmp exemplo_04_1.c -o exemplo_04_1
gcc -fopenmp exemplo_04_1_private.c -o exemplo_04_1_private
gcc -fopenmp exemplo_04_2.c -o exemplo_04_2
gcc -fopenmp exemplo_04_3.c -o exemplo_04_3
gcc -fopenmp exemplo_04_4.c -o exemplo_04_4
gcc -fopenmp exemplo_04.c -o exemplo_04
gcc -fopenmp exemplo_04_firstprivate.c -o exemplo_04_firstprivate
gcc -fopenmp exemplo_04_lastprivate.c -o exemplo_04_lastprivate
gcc -fopenmp exemplo_04_ordered.c -o exemplo_04_ordered
gcc -fopenmp exemplo_04_private.c -o exemplo_04_private
gcc -fopenmp exemplo_4_omp_dynamic.c -o exemplo_4_omp_dynamic

echo '*** COMPILACAO OK ***'

#!/bin/bash
#SBATCH --nodes=1                      #Numero de Nós
#SBATCH --ntasks-per-node=1            #Numero de tarefas por Nó
#SBATCH --ntasks=1                     #Numero total de tarefas MPI
#SBATCH --cpus-per-task=24             #Numero de threads
#SBATCH -p treinamento                 #Fila (partition) a ser utilizada
#SBATCH -J semana-sdumont-openmp       #Nome job

module load gcc-5

NUM_THREAD=${1}
EXEC=${2}
ARG1=${3}

export OMP_NUM_THREADS=${NUM_THREAD}

srun -N 1 -c ${NUM_THREAD} ${EXEC} ${ARG1}

#!/bin/bash -l

function print_usage() {
    echo ""
    echo "Usage:"
    echo "      ./create_run_scripts.sh <matsize>"
    echo "          matsize:    MxN, with M and N as integers"
    echo ""
    echo "      Options:"
    echo "          -h | --help: Prints usage."
    echo ""
}

if [ $# -lt 1 ]
then
    echo "A matrix size is required."
    print_usage
    exit
fi

if [[ $1 == '-h' || $1 == '--help' ]]
then
    print_usage
    exit
fi

MATSIZE=$1
OUTFILE=run_jacobi-openacc_cpu_$MATSIZE.sh

echo "Creating run script for matrix size $1..."

echo "#!/bin/bash -l" > $OUTFILE
echo "#PBS -l nodes=1" >> $OUTFILE
echo "#PBS -q debug" >> $OUTFILE
echo "#PBS -l walltime=00:30:00" >> $OUTFILE
echo "#PBS -N openacc.prof.j.$MATSIZE" >> $OUTFILE
echo "#PBS -j oe" >> $OUTFILE
echo "#PBS -A stf007" >> $OUTFILE
echo "" >> $OUTFILE
echo "cd \$PBS_O_WORKDIR" >> $OUTFILE
echo "" >> $OUTFILE
echo "module load cudatoolkit" >> $OUTFILE
echo "module list" >> $OUTFILE
echo "" >> $OUTFILE
echo "export COMPUTE_PROFILE=1" >> $OUTFILE
echo "export COMPUTE_PROFILE_LOG=/lustre/atlas1/stf007/proj-shared/vgv/omp4cug/nvprof-logs/output.${MATSIZE}.\$HOSTNAME.%p" >> $OUTFILE
echo "" >> $OUTFILE
echo "INFILE=../inputs/input.$MATSIZE" >> $OUTFILE
echo "" >> $OUTFILE
echo "echo \"Jacobi OpenACC on GPU\"" >> $OUTFILE
echo "time -p aprun -n 1 ./j.openacc.cpu < \$INFILE" >> $OUTFILE
echo "" >> $OUTFILE
echo "echo \"\"" >> $OUTFILE

#!/bin/bash

module load gcc-5

gcc -fopenmp racecar_omp.c -o racecar_omp
gcc -fopenmp racecar_single_two_task.c -o racecar_single_two_task
gcc -fopenmp racecar_task_wait.c -o racecar_task_wait
gcc -fopenmp racecar.c -o racecar
gcc -fopenmp racecar_omp_single.c -o racecar_omp_single
gcc -fopenmp racecar_task.c -o racecar_task

echo '*** COMPILACAO COMPLETADA ***'

#!/bin/bash

module load gcc-5
source /scratch/app/modulos/intel-psxe-2016.2.062.sh

mpiicc -qopenmp xthi.c -o xthi-mpi
gcc -fopenmp xthi-nested-omp.c -o xthi-nested-omp
gcc -fopenmp xthi-omp.c -o xthi-omp

#!/bin/bash

module load gcc-5

gcc -fopenmp exemplo_07_atomic.c -o exemplo_07_atomic
gcc -fopenmp exemplo_07.c -o exemplo_07
gcc -fopenmp exemplo_07_corrida.c -o exemplo_07_corrida

echo '*** COMPILACAO COMPLETADA ***'

#!/bin/bash

module load gcc-5

gcc -fopenmp exemplo_08.c -o exemplo_08
gcc -fopenmp exemplo_08_com_barrier.c -o exemplo_08_com_barrier
gcc -fopenmp exemplo_08_corrida.c -o exemplo_08_corrida
gcc -fopenmp exemplo_08_sem_barrier.c -o exemplo_08_sem_barrier

echo '*** COMPILACAO COMPLETADA ***'
